<?php
/**
 * @author La clic ! <contact@laclic.fr>
 */

namespace Lc\CaracoleBundle\Model\Credit;


use Lc\CaracoleBundle\Doctrine\Extension\PayoffTrait;
use Lc\CaracoleBundle\Model\Order\OrderPaymentInterface;
use Lc\CaracoleBundle\Model\Order\OrderRefundInterface;
use Lc\CaracoleBundle\Model\User\UserMerchantInterface;
use Lc\SovBundle\Doctrine\Extension\BlameableTrait;
use Lc\SovBundle\Doctrine\Extension\DevAliasTrait;
use Lc\SovBundle\Doctrine\Extension\TimestampableTrait;
use Lc\SovBundle\Model\User\UserInterface;

/**
 * @ORM\MappedSuperclass()
 */
interface CreditHistoryInterface
{
    public function getCreatedBy(): ?UserInterface;

    public function setCreatedBy(?UserInterface $createdBy);

    public function getUpdatedBy(): ?UserInterface;

    public function setUpdatedBy(?UserInterface $updatedBy);

    public function __toString();

    public function getAmount(): ?float;

    public function setAmount(?float $amount);

    public function getAmountInherited(): float;

    public function getMeanPaymentInherited(): string;

    public function getPaidAtInherited(): ?\DateTimeInterface;

    public function getReferenceInherited(): ?string;

    public function getCommentInherited(): ?string;

    public function getMeanPaymentInheritedLabel(): string;

    public function getType(): ?string;

    public function setType(string $type): CreditHistoryModel;

    public function getUserMerchant(): ?UserMerchantInterface;

    public function setUserMerchant(?UserMerchantInterface $userMerchant): CreditHistoryModel;

    public function getOrderPayment(): ?OrderPaymentInterface;

    public function setOrderPayment(?OrderPaymentInterface $orderPayment): CreditHistoryModel;

    public function getOrderRefund(): ?OrderRefundInterface;

    public function setOrderRefund(?OrderRefundInterface $orderRefund): CreditHistoryModel;

    public function getDevAlias(): ?string;

    public function setDevAlias(?string $devAlias);

    public function setMeanPayment(?string $meanPayment): CreditHistoryModel;

    public function getMeanPayment(): ?string;

    public function getReference(): ?string;

    public function setReference(?string $reference): CreditHistoryModel;

    public function getPaidAt(): ?\DateTimeInterface;

    public function setPaidAt(?\DateTimeInterface $paidAt): CreditHistoryModel;

    public function getComment(): ?string;

    public function setComment(?string $comment): CreditHistoryModel;

    public function getCreatedAt(): ?\DateTimeInterface;

    public function setCreatedAt(\DateTimeInterface $createdAt);

    public function getUpdatedAt(): ?\DateTimeInterface;

    public function setUpdatedAt(\DateTimeInterface $updatedAt);
}